LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY acff IS 
	port
	(
		LIN :  INOUT  STD_LOGIC_VECTOR(0 DOWNTO 0);
		LOUT : INOUT STD_LOGIC_VECTOR(0 DOWNTO 0);
		ROUT : INOUT STD_LOGIC_VECTOR(0 DOWNTO 0);
		RIN :  INOUT  STD_LOGIC_VECTOR(0 DOWNTO 0)
	);
END acff;

ARCHITECTURE concept OF acff IS 

component bus_relay
generic     (N : positive :=1);
port        (IO1 : inout std_logic_vector(N-1 downto 0);
             S   : in std_logic_vector(1 downto 0);
             IO2 : inout std_logic_vector(N-1 downto 0) );
end component;

component diode
port 
	(
	  p_Out : out std_logic;
	  p_In : in std_logic
	);
end component;

signal	wire0 :  STD_LOGIC;
signal	wire1 :  STD_LOGIC;
signal  wire2 :  STD_LOGIC_VECTOR(1 DOWNTO 0);
signal  wire3 :  STD_LOGIC_VECTOR(1 DOWNTO 0);

BEGIN
	
wire1 <= wire0 AND LIN(0);
d1: diode port map(LOUT(0),wire1);
b1: bus_relay port map(LIN,wire2,LOUT);

wire0 <= wire1 OR RIN(0);
d2: diode port map(ROUT(0),wire0);
b2: bus_relay port map(RIN,wire3,ROUT);

END;